SystemWindow subclass: #CompoDiagramWindow
	instanceVariableNames: 'comp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compo-Morphs'!

!CompoDiagramWindow methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/20/2011 16:58'!
comp
	^ comp.! !

!CompoDiagramWindow methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 12:31'!
createView 
	| whiteboard   scrollPane|

	whiteboard := Morph new color: Color white.
	whiteboard extent: 1000@1000.
	whiteboard position: 0@0.

	comp := CompoComponentMorph on: (Smalltalk at: #Component) .
	
	whiteboard addMorph: comp.

	scrollPane := ScrollPane new.
	scrollPane scroller addMorph: whiteboard..
	self addMorph: scrollPane frame: (0@0 corner: 1@1).
	self setLabel: (self name).

	! !

!CompoDiagramWindow methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/17/2011 18:08'!
initialize
	super initialize.
	self createView.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CompoDiagramWindow class
	instanceVariableNames: ''!

!CompoDiagramWindow class methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/17/2011 18:03'!
open
	|inst|
	inst := self new.
	inst openInWorld.
	^ inst. ! !


RectangleMorph subclass: #CompoPortMorph
	instanceVariableNames: 'model nameMorph connectPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compo-Morphs'!

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 14:37'!
connectPoint
	^ connectPoint ifNil: [self bounds center].! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 14:42'!
connectPoint: aPoint
	connectPoint:= aPoint.! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/18/2011 11:33'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white.! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 15:05'!
defaultConnectCircleRadius
	^ 7.! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/28/2011 12:54'!
defaultFontSize
	^ 9! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/20/2011 10:59'!
drawOn: aCanvas
	aCanvas fillRectangle: self bounds color: self color.
	aCanvas frameRectangle: self bounds width: 2 color: (Color black).! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 11:30'!
initialize
	super initialize.
	
	nameMorph := TextMorph new.
	nameMorph autoFit: true.
	self addMorph: nameMorph.
	
	self setProperty: #scaleFactor toValue: 1.0 .

! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 11:34'!
maxX
	^ self bounds corner x.! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 18:38'!
maxY
	^ self corner y.! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 12:51'!
minX
	^ self bounds origin x.! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 18:38'!
minY
	^ self origin y.! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/24/2011 15:09'!
model: aPortDesc
	model := aPortDesc.
	self modelChanged.! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 11:48'!
modelChanged
	|nT|
	nT := ((((((model instVarNamed: #ports) at: #name) instVarNamed: #ports) at: #connectedPorts) instVarNamed: #connectedPorts) at: 1) instVarNamed: #owner.
	nameMorph contents: nT asText.

! !

!CompoPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/28/2011 12:53'!
scale: newScale
	self setProperty: #scaleFactor toValue: newScale .

	
	nameMorph beAllFont: (LogicalFont familyName: 'DejaVu Serif' pointSize: (self defaultFontSize * newScale)).

	self bounds: (nameMorph bounds outsetBy: (5*newScale)).
	nameMorph position: (self position translateBy: (5@5 * newScale )).
	
	self layoutChanged.
	self changed.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CompoPortMorph class
	instanceVariableNames: ''!

!CompoPortMorph class methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/24/2011 15:03'!
on: aPortDesc
	|inst|
	inst := self new.
	inst model: aPortDesc.
	
	^ inst.! !


RectangleMorph subclass: #CompoComponentMorph
	instanceVariableNames: 'model nameMorph mainContainer provsContainer reqsContainer internalContainer firstTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compo-Morphs'!

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 19:42'!
defaultBounds
"answer the default bounds for the receiver"
	^ 0 @ 0 corner: 400 @ 300! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 12:48'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color transparent .! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 19:42'!
defaultComponentBounds
	^ 10 @ 10 corner: 330 @ 210! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 18:18'!
defaultComponentColor
	^ Color white.! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/28/2011 12:54'!
defaultComponentFontSize

	^ 12.! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 18:00'!
defaultComponentPortsSpacing

	^ 5.! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 12:08'!
drawOn: aCanvas
	|compIconRect|
	
	aCanvas fillRectangle: self bounds color: self color.
	
	aCanvas fillRectangle: mainContainer bounds color: self defaultComponentColor.
	aCanvas frameRectangle: mainContainer bounds width: 2 color: (Color black).
	
	compIconRect := mainContainer bounds insetBy: 5.
	
	compIconRect setOrigin: (compIconRect origin + ((compIconRect width * 0.9)@0)) corner: (compIconRect corner).
	compIconRect := compIconRect withHeight: (compIconRect width *0.75).
	
	aCanvas fillRectangle: compIconRect color: self defaultComponentColor.
	aCanvas frameRectangle: compIconRect width: 1 color: (Color black).
	
	compIconRect := compIconRect withWidth: (compIconRect width *0.4).
	compIconRect := compIconRect withHeight: (compIconRect height *0.3).
	compIconRect := compIconRect translateBy: ( (-1*(compIconRect width / 3))@((compIconRect height / 2)) ).
	
	aCanvas fillRectangle: compIconRect color: self defaultComponentColor.
	aCanvas frameRectangle: compIconRect width: 1 color: (Color black).
	
	compIconRect := compIconRect translateBy: ( 0@(1.5 * compIconRect height) ).
	
	aCanvas fillRectangle: compIconRect color: self defaultComponentColor.
	aCanvas frameRectangle: compIconRect width: 1 color: (Color black).


		
	
	! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 11:25'!
getPortDescriptionsOfDescriptor: desc
	|pds res|
	"get port to which port-descriptions are connected"
	
	pds := (desc instVarNamed: #ports) at: #ports.
	res := OrderedCollection new.
	(((pds instVarNamed: #ports) at: #connectedPorts) instVarNamed: #connectedPorts)
		do: [ :aPort | res add: ((aPort instVarNamed: #owner) instVarNamed: #owner)].
	^res asArray.! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 11:38'!
initialize
	
	super initialize.
	
	firstTime := true.
	
	nameMorph := TextMorph new..
	nameMorph autoFit: true..

	self setProperty: #scaleFactor toValue: 1.0 .
	
	mainContainer := BorderedMorph new.
	self addMorph: mainContainer.
	mainContainer color: (Color transparent).
	mainContainer bounds: (self defaultComponentBounds).
	
	provsContainer := Morph new.
	reqsContainer := Morph new.
	internalContainer := Morph new.
		
	provsContainer layoutPolicy: TableLayout new; cellInset: (self defaultComponentPortsSpacing).
	reqsContainer layoutPolicy: TableLayout new; cellInset: (self defaultComponentPortsSpacing)..
	internalContainer layoutPolicy: TableLayout new; listDirection: #leftToRight.
	
	provsContainer color: Color transparent.
	reqsContainer color: Color transparent.
	internalContainer color: Color transparent.! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 17:45'!
label
	^ nameMorph contents.! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 17:44'!
label: aString
	nameMorph contents: (aString asText). ! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/24/2011 15:09'!
model: aCompDesc
	model := aCompDesc.
	self modelChanged.! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 12:51'!
modelChanged
	mainContainer removeAllMorphs.
	provsContainer removeAllMorphs.
	reqsContainer removeAllMorphs.
	internalContainer removeAllMorphs.
	
	self label: model name.
	
	mainContainer addMorph: nameMorph.
	mainContainer addMorph: provsContainer.
	mainContainer addMorph: reqsContainer.
	mainContainer addMorph: internalContainer.
	
	(self getPortDescriptionsOfDescriptor:  model) do: [:desc |
		|role visibility|
		role := ((((((desc instVarNamed: #ports) at: #role) instVarNamed: #ports) at: #connectedPorts) instVarNamed: #connectedPorts) at: 1) instVarNamed: #owner.
		visibility := ((((((desc instVarNamed: #ports) at: #visibility) instVarNamed: #ports) at: #connectedPorts) instVarNamed: #connectedPorts) at: 1) instVarNamed: #owner.
		((role = #required) and: [ visibility = #internal ])
			ifTrue: [ provsContainer addMorph: (CompoRequiredPortMorph on: desc) ].
		((role = #required) and: [ visibility = #external ])
			ifTrue: [ reqsContainer addMorph: (CompoRequiredPortMorph on: desc) ].
		((role = #provided) and: [ visibility = #internal ])
			ifTrue: [ reqsContainer addMorph: (CompoProvidedPortMorph on: desc) ].
		((role = #provided) and: [ visibility = #external ])
			ifTrue: [ provsContainer addMorph: (CompoProvidedPortMorph on: desc) ].
	].

	"
	model internalComponentsDescriptors do: [:desc |
		internalContainer addMorph: (CompoComponentMorph on: (desc defaultDescriptor) labeled: (desc printString)).
	].
	"

	self scale: (self valueOfProperty: #scaleFactor ).! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 12:44'!
recomputeBounds
	|maxX minX maxY minY|
	(firstTime) ifTrue: [ firstTime := false. "self halt." ].
	minX := mainContainer bounds origin x.
	minY := mainContainer bounds origin y.
	provsContainer submorphs do: [ :p | ((p minX) < minX) ifTrue: [ minX:= p minX ]].
	
	maxX := (mainContainer bounds corner x).
	maxY := (mainContainer bounds corner y).
	reqsContainer submorphs do: [ :p | ((p maxX) > maxX) ifTrue: [ maxX:= p maxX ]].

	
	self bounds: (((minX@minY) corner: (maxX@maxY)) outsetBy: 10).
	self position: (-1@1)*(minX@minY).
	
	self submorphs do: [ :p | p position: (p position + ((provsContainer height + 10)@0)) ].! !

!CompoComponentMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 12:59'!
scale: newScale
	|maxW sumH|

	self setProperty: #scaleFactor toValue: newScale .
	
	nameMorph beAllFont: (LogicalFont familyName: 'DejaVu Serif' pointSize: (self defaultComponentFontSize * newScale)).
	nameMorph position: (((mainContainer bounds topCenter x / 2)@0)+(mainContainer position translateBy: (5@5 * newScale ))).
	
	mainContainer bounds: (self defaultComponentBounds scaleBy: newScale).
	

	internalContainer submorphs do: [:sub |  sub scale: (0.4 * newScale) ].	
	provsContainer submorphs do: [:sub | sub scale: newScale].
	reqsContainer submorphs do: [:sub | sub scale: newScale].
	
	mainContainer height:  (1.3* (mainContainer height)).
	
	internalContainer bounds: (mainContainer bounds insetBy: (0.1 * (self width))). 
	
	maxW := 0. 
	provsContainer submorphs do: [:sm | (sm width > maxW) ifTrue: [maxW := sm width]].
	sumH := -1 * (self defaultComponentPortsSpacing).
	provsContainer submorphs do: [:sm | sumH := sumH + sm height + self defaultComponentPortsSpacing ].
	provsContainer position: (mainContainer bounds leftCenter translateBy: ( (-1 * maxW /2) @ (-1 * sumH /2) )) .
	
	maxW := 0. 
	reqsContainer submorphs do: [:sm | (sm width > maxW) ifTrue: [maxW := sm width]].
	sumH := -1 * (self defaultComponentPortsSpacing).
	reqsContainer submorphs do: [:sm | sumH := sumH + sm height + self defaultComponentPortsSpacing ].
	reqsContainer position: (mainContainer bounds rightCenter translateBy: ( (-1 * maxW /2) @ (-1 * sumH /2) )) .
	
	self recomputeBounds.
	
	self layoutChanged.
	self changed.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CompoComponentMorph class
	instanceVariableNames: ''!

!CompoComponentMorph class methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/24/2011 14:56'!
on: aCompDesc
	|inst|
	inst := self new.
	inst model: aCompDesc.
	
	^ inst.! !

!CompoComponentMorph class methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 16:52'!
on: aCompDesc labeled: aString
	|inst|
	inst := self on: aCompDesc.
	inst label: aString.
	^ inst.! !


CompoPortMorph subclass: #CompoProvidedPortMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compo-Morphs'!

!CompoProvidedPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 15:05'!
connectPoint
	^ connectPoint ifNil: [ (self bounds leftCenter) - (20@0) ].! !

!CompoProvidedPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 15:03'!
drawOn: aCanvas
	|rect v|
	super drawOn: aCanvas.
	v := ((self defaultConnectCircleRadius)@(self defaultConnectCircleRadius)).
	rect := Rectangle origin: (self connectPoint - v ) corner: (self connectPoint + v ) .

	aCanvas line: (self bounds leftCenter) to: (self connectPoint) width: 2 color: Color black.	
	aCanvas fillOval: rect color: self defaultColor.
	aCanvas frameOval: rect width: 2 color: Color black.
	
	! !

!CompoProvidedPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 18:45'!
minX
	^ ((self connectPoint x) - self defaultConnectCircleRadius).! !

!CompoProvidedPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/24/2011 16:27'!
scale: newScale
	super scale: newScale.
	
	
	"self position: (self owner bounds leftCenter translateBy: ( (-1 * self  width /2) @ (-1 * self  height /2) )) ."
	
	self layoutChanged.
	self changed.! !


CompoPortMorph subclass: #CompoRequiredPortMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compo-Morphs'!

!CompoRequiredPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 15:05'!
connectPoint
	^ connectPoint ifNil: [ (self bounds rightCenter) + (20@0) ].! !

!CompoRequiredPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 11/22/2013 11:51'!
drawOn: aCanvas
	|rect v cm smooth|
	super drawOn: aCanvas.
	v := ((self defaultConnectCircleRadius)@(self defaultConnectCircleRadius)).
	rect := Rectangle origin: (self connectPoint - v ) corner: (self connectPoint + v ) .
	
	smooth := 60.
	1 to: smooth do: [:i |
		aCanvas
			line: (rect topCenter rotateBy: ( (i - 1) * ((Float pi) / smooth) ) about: (self connectPoint))
			to: (rect topCenter rotateBy: ( i * ((Float pi) / smooth) ) about: (self connectPoint))
			width: 2
			color: Color black.	
	].


	v instVarNamed: #y put:  0.
	aCanvas line: (self bounds rightCenter) to: ((self connectPoint) - (v))  width: 2 color: Color black.	! !

!CompoRequiredPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/27/2011 18:45'!
maxX
	^ ((self connectPoint x) + self defaultConnectCircleRadius).! !

!CompoRequiredPortMorph methodsFor: 'as yet unclassified' stamp: 'PetrSpacek 10/24/2011 16:28'!
scale: newScale
	super scale: newScale.
	
	"self position: (self owner bounds rightCenter translateBy:  ( (-1 * self  width /2) @ (-1 * self  height /2) )) ."
	
	self layoutChanged.
	self changed.
	! !
