'From Pharo2.0 of 7 March 2013 [Latest update: #20619] on 10 November 2013 at 5:15:36 pm'!


!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 17:30'!
injection
	^ nil.! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 17:30'!
injection: val
	! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 17:30'!
interface: val
	! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 17:30'!
name: val
	! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 21:51'!
owner
	|potencialOwners|
	self myDependents ifNil: [^nil].
	potencialOwners := self myDependents select: [ :d | 
		(((d isKindOf: (Smalltalk at: #Component)) or:
	[d isKindOf: (Smalltalk at: #AtomicPortOwnerFake)]) or: [d isKindOf: (Smalltalk at: #ObjectOwnerFake)])	
	].
	(potencialOwners size > 1) ifTrue: [self error: 'Object can be owned by one component only!!'].
	(potencialOwners isEmpty) ifTrue: [ ^ nil ].
	^ potencialOwners anyOne.
	! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 11/5/2012 15:47'!
owner: val
	|ownedPrimitives prev wrappedOwner|
	
	"first we have to wrap the original owner, this is because an object behaves as a port, and ports are owned by components,
	which may be owned by another components (being internal components)"
	wrappedOwner := ObjectOwnerFake new owner: val.
	
	"Objects can be owned by instances of Component only!!
	for testing purposes, Object can be owned by instances of AtomicPortOwnerFake or ObjectOwnerFake"
	(((val isKindOf: (Smalltalk at: #Component)) or:
	[val isKindOf: (Smalltalk at: #AtomicPortOwnerFake)]) or: [val isKindOf: (Smalltalk at: #ObjectOwnerFake)])
		ifFalse: [self error: 'Objects can be owned by instances of Component only!!'].
	
	"we clear previous owner, if any"
	self releaseOwner.
	

	ownedPrimitives := wrappedOwner instVarAt: (wrappedOwner class instVarIndexFor: #ownedPrimitives).
	ownedPrimitives add: self.
	
	self addDependent: wrappedOwner.! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 11/5/2012 15:52'!
release
	"Remove references to objects that may refer to the receiver. This message 
	should be overridden by subclasses with any cycles, in which case the 
	subclass should also include the expression super release."
	self releaseOwner.
	self releaseActionMap! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 11/5/2012 15:53'!
releaseOwner
	[
		|prev ownedPrimitives |
		prev := self owner.
		prev ifNotNil: [
			ownedPrimitives := prev instVarAt: (prev class instVarIndexFor: #ownedPrimitives).
			ownedPrimitives remove: self ifAbsent: [].
			self removeDependent: prev.
		].
	] on: Error do: [].! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 17:32'!
role
	^ #provided
	! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 17:31'!
role: val
	! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 17:31'!
visibility
	^ #external
	! !

!Object methodsFor: '*Compo-atomicport-accessing' stamp: 'PetrSpacek 10/22/2012 17:31'!
visibility: val
	! !
